package com.sun.asqe.entitystateless.helloworld.client;					

import javax.naming.*;
import javax.ejb.*;
import javax.annotation.*;

import com.sun.asqe.entitystateless.helloworld.ejb.*;
import com.sun.ejte.ccl.reporter.SimpleReporterAdapter;

public class Client {

    private static SimpleReporterAdapter stat =
        new SimpleReporterAdapter();

    @EJB    
    private static HelloWorldRemote helloWorld;

    public static void main(String [] args) {
        stat.addDescription("stateless-HelloWorldApp");
        String result = "";

		try {
            if(helloWorld!=null){
                stat.addStatus("stateless:helloworld:init-lookup", stat.PASS);
            } else {
                stat.addStatus("stateless:helloworld:init-lookup", stat.FAIL);
            }
            
            result = helloWorld.sayHi();
            if(!result.equals("")){
                echo("Client: result is:"+result);
                stat.addStatus("stateless:helloworld:sayHi", stat.PASS);                
            } else {
                stat.addStatus("stateless:helloworld:sayHi", stat.FAIL);                
            }

            result="";
            result = helloWorld.testCompositePK();
            if(result.equals("car found!")){
                echo("Client: result is:"+result);
                stat.addStatus("stateless:helloworld:testCompositePK", stat.PASS);
            } else {
                stat.addStatus("stateless:helloworld:testCompositePK", stat.FAIL);
            }
        } catch (Exception re){
            echo("Client: caught Exception");
            re.printStackTrace();
                stat.addStatus("stateless:helloworld:testCompositePK", stat.FAIL);
        } catch (Throwable t){
              echo("Client: caught throwable");
              t.printStackTrace();
                stat.addStatus("stateless:helloworld:testCompositePK", stat.FAIL);
        } finally {
            echo("printing summary..."); 
            stat.printSummary(); 
        }
   }
    
    public static void echo(String msg) {
        System.out.println(msg);
    }
}
