package com.sun.asqe.entitystateless.ejb.car;

import javax.ejb.*;
import javax.persistence.*;
import javax.annotation.*;
import java.util.*;
import com.sun.asqe.entitystateless.ejb.driver.*;
import com.sun.asqe.entitystateless.ejb.car.*;

@Entity
public class Car{

    private CarPK carPK;
    Driver driver; // car belongs to a driver

    public Car(){}

    public Car(String lplate, String state){
        this.carPK = new CarPK(lplate, state);
    }

    @EmbeddedId
    public CarPK getCarPK(){ return this.carPK; }
    public void setCarPK(CarPK id){ this.carPK=carPK; }

    @ManyToOne
    @JoinColumns({
        @JoinColumn(name="DRIVER_LNO", referencedColumnName="LNO"),
        @JoinColumn(name="DRIVER_STATE", referencedColumnName="STATE")
    })
    public Driver getDriver() { return this.driver;}
    public void setDriver(Driver driver) { this.driver = driver;}
    
	// standard call back methods
    @PostLoad
    public void load(){ echo("Car: just Loaded"); }

    @PostPersist
    public void store(){ echo("Car: just persisted"); }

    @PostActivate
    public void activate(){ echo("Car: just Activated"); }

    @PrePassivate
    public void passivate(){ echo("Car: about to Passivate"); }

    @Remove
    public void remove(){ echo("Car: Inside ejbRemove"); }

    public void echo (String msg){
        System.out.println(msg);
    }

    public String toString(){
        CarPK c = getCarPK();
        return "\nLicense Plate: "+c.getLPlate()+": Car State :"+c.getState();
    }

}
