package com.sun.asqe.entitystateless.ejb.driver;

import javax.ejb.*;
import javax.persistence.*;
import javax.annotation.*;
import java.util.*;
import com.sun.asqe.entitystateless.ejb.driver.*;
import com.sun.asqe.entitystateless.ejb.car.*;

@IdClass(com.sun.asqe.entitystateless.ejb.driver.DriverPK.class)
@Entity
public class Driver{


    @Id 
    @Column(name="LICENSE_NUMBER")//,insertable=false, updatable=false) 
    String lno;

    @Id 
    @Column(name="STATE")//,insertable=false, updatable=false) 
    String state;

    @OneToMany(cascade=CascadeType.ALL, mappedBy="driver")
    Collection<Car> cars; //Driver may have many cars

    public Driver(){}

    public Driver(String lno, String state){
        this.lno = lno;
        this.state = state;
    }

    public DriverPK buildPK(){ 
        DriverPK driverPK = new DriverPK(this.lno, this.state);
        return driverPK; 
    }
    
    public Collection<Car> getCars(){ return this.cars; }
    public void setCars(Collection<Car> cars){ this.cars = cars; }
    
	// standard call back methods
    @PostLoad public void load(){ echo("Driver: just Loaded"); }
    @PostPersist public void store(){ echo("Driver: just persisted"); }
    @PostActivate public void activate(){ echo("Driver: just Activated"); }
    @PrePassivate public void passivate(){ echo("Driver: about to Passivate"); }
    @Remove public void remove(){ echo("Driver: Inside ejbRemove"); }

    public void echo (String msg){
        System.out.println(msg);
    }

}

