package com.sun.asqe.entitystateless.helloworld.ejb;

import javax.ejb.*;
import javax.annotation.*;
import javax.persistence.*;
import java.util.*;
import com.sun.asqe.entitystateless.ejb.car.*;
import com.sun.asqe.entitystateless.ejb.driver.*;

@Stateless
@Remote({HelloWorldRemote.class})
public class HelloWorldBean implements HelloWorldRemote{

    @PersistenceContext EntityManager em;
    String msg;
    String carStr;
    //StringBuffer msgbuf = new StringBuffer();

   public String testCompositePK() throws Exception {
       //---car test
       System.out.println("HelloWorldBean:testCompositePK");
       String lplate="1ab2cd3";
       String state="California";
       Car car = new Car(lplate, state);
       System.out.println("HelloWorldBean:testCompositePK:created car. "+
               "persisting...");
       System.out.println("em class is:"+em.getClass().getName());
       em.persist(car);
       System.out.println("HelloWorldBean:testCompositePK:persisted car.");

       //---driver test
       String lno="D1234567";
       Driver driver = new Driver(lno, state);
       System.out.println("HelloWorldBean:testCompositePK:created driver. "+
               "persisting...");
       System.out.println("em class is:"+em.getClass().getName());
       em.persist(driver);
       System.out.println("HelloWorldBean:testCompositePK:persisted driver."+
               "now removing...");

       DriverPK driverPK = driver.buildPK();
       System.out.println("HelloWorldBean:testCompositePK:created driverPK."+
              " finding...");
       ArrayList carList = new ArrayList();
       carList.add(car);
       driver.setCars(carList);

       car = null;
       CarPK carPK = new CarPK(lplate, state);
       System.out.println("HelloWorldBean:testCompositePK:created carPK. "+
               "finding...");
       car = em.find(Car.class, carPK);
       if(car==null){msg = "car NOT found";}else{msg = "car found!";}
       System.out.println("HelloWorldBean:testCompositePK:"+msg);
       //System.out.println("HelloWorldBean:testCompositePK:removing car...");
       //em.remove(car);

       driver = null;
       driver = em.find(Driver.class, driverPK);
       if(driver==null) { 
            System.out.println("Driver NULL");
            //msgAdd = msg.concat(":Driver Null");
            //msgbuf.append(msg);
       }else{
            System.out.println("Driver FOUND!");
            // add getCars test
            //msgAdd = msg.concat(":Driver FOUND");
            //msgbuf.append(msg);
            Collection c = driver.getCars();
            if(c!=null){
                Iterator i = c.iterator();
                while(i.hasNext())
                    //carStr=((Car)i.next()).toString();
                    System.out.println(carStr);
                    //msgbuf.append( ":"+carStr );
            }
       }
       System.out.println("HelloWorldBean:testCompositePK:"+msg);
       //System.out.println("HelloWorldBean:testCompositePK:removing driver...");
       //em.remove(driver);
       
       return "String is breaking";
       //return msgbuf.toString();
    }

    public String sayHi(){
        return "hi there!";
    }

}
